<link rel="import" href="../../bower_components/polymer/polymer-element.html">
<link rel="import" href="../../bower_components/polymer/lib/elements/dom-repeat.html">
<link rel="import" href="./../../bower_components/iron-collapse/iron-collapse.html">
<link rel="import" href="./../dp/pokemon-dp.html">

<dom-module id="pokemon-element">
  <template>
    <style>
      :host {
        display: inline-block;
      }
      .collapse-content {
        padding: 15px;
        border: 1px solid #dedede;
      }
      .card{
                background: #039be5;
                width: 260px;
                min-height: 100px;
                padding: 15px;
                margin-top: 5px;
            }
            span, h4{
                font-weight: bold;
                font-weight: 600;
                color: white;
            }
            h4 {
                font-weight: lighter;
                padding: 0;
                margin: 0;
            }
            .text-default{
              margin-top: 10px;
            }
    </style>
    <div>
    <iron-collapse class="card" opened="[[!_show]]" id="title" on-click="toggle">
      <div class="collapse-content" >
        <span>[[name]]</span>
      </div>
    </iron-collapse>
    <iron-collapse class="card" opened="[[_show]]" id="detail" on-click="toggle">
      <div class="collapse-content" >
        <img src="[[detail.sprites.back_default]]" height="150"/>
        <h4>abilities:</h4>
        <template is="dom-repeat" items="[[detail.abilities]]" as="pkm">
          <h4>- [[pkm.ability.name]]</h4>
        </template>
        <h4 class="text-default">height: [[detail.height]]</h4>
        <h4 class="text-default">weight: [[detail.weight]]</h4>
      </div>
    </iron-collapse>
  </div>
  <pokemon-dp id="provider_detail" result="{{detail}}"></pokemon-dp>
  </template>

  <script>
    /**
     * @customElement
     * @polymer
     */
    class PokemonElement extends Polymer.Element {
      static get is() { return 'pokemon-element'; }
      static get properties() {
        return {
          name: {
            type: String,
            notify: true
          },
          url: {
            type: String,
            notify: true
          },
          detail:{
            type: Object,
            notify: true
          },
          _show:{
            type: Boolean,
            value: false
          }
        };
      }
      toggle(){
        this._show = !this._show;
        if(this._show){
          this.$.provider_detail.getDetail(this.url);
        }
      }
    }

    window.customElements.define(PokemonElement.is, PokemonElement);
  </script>
</dom-module>
